//参考：
// https://github.com/vuejs/vuepress/blob/master/packages/docs/docs/.vuepress/config.js
// https://vuepress-theme-reco.recoluan.com/views/1.x/
module.exports = {
  title: '信息部技术培训-初级篇',
  description: '信息部新入职员工培训材料',
  // base:'/docs/',

  theme: 'vuepress-theme-reco',
  themeConfig: {
    //腾讯 404 公益配置
    noFoundPageByTencent: false,

    mode: 'light', // 默认 auto，auto 跟随系统，dark 暗色模式，light 亮色模式
    modePicker: false, // 默认 true，false 不显示模式调节按钮，true 则显示

    // author
    author: 'xxb',

    // if your docs are in a different repo from your main project:
    docsRepo: 'https://git.xxb.lttc.cn/xxb-train/dev-train-doc',
    // if your docs are in a specific branch (defaults to 'master'):
    docsBranch: 'master',
    // if your docs are not at the root of the repo:
    //docsDir: 'doc',
    // defaults to false, set to true to enable
    editLinks: true,
    // custom text for edit link. Defaults to "Edit this page"
    editLinkText: '编辑此页面',


    lastUpdated: '更新时间', // string | boolean

    nav: [
      { text: '首页', link: '/' },
      { text: 'SQL', link: '/sql/' },
      { text: 'C#', link: '/csharp/' },
      { text: 'WinForm', link: '/winform/' },
      { text: 'WinForm专题', link: '/winformspecialtopic/' },
    ],

    sidebar: {
      '/sql/': [
        {
          title: 'SQL简介',
          collapsable: false,
          children: [
            { title: '简介', path: '/sql/' },
            { title: '安装', path: '/sql/01.install' },
            { title: '库表操作', path: '/sql/02.db&table' },
            { title: '单表操作', path: '/sql/03.singletable' },
            { title: '多表操作', path: '/sql/04.multitable' },
            { title: '分组、聚合函数', path: '/sql/05.group' },
            { title: '索引', path: '/sql/06.index' },
            { title: '视图', path: '/sql/07.view' },
            { title: '触发器', path: '/sql/08.trigger' },
            { title: '存储过程', path: '/sql/09.procedure' },
            { title: '窗口函数', path: '/sql/10.windowsfunc' },
            { title: '事务', path: '/sql/11.transaction' },
            { title: '常用函数', path: '/sql/12.commonfunc' },
          ],
        },
      ],


      '/csharp/': [{
        title: '认识c#',
        collapsable: false,
        children: [
          { title: '简介', path: '/csharp/' },
          { title: '数据类型', path: '/csharp/01.dbtype' },
          { title: '类', path: '/csharp/02.class' },
          { title: '接口、继承与多态', path: '/csharp/03.interface' },
          { title: '基础语法', path: '/csharp/04.syntax' },
          { title: '数组与集合', path: '/csharp/05.array' },
          { title: '字符串', path: '/csharp/06.string' },
          { title: '内存对象', path: '/csharp/07.memoryobject' },
          { title: '数据库操作', path: '/csharp/08.dbop' },
          {
            title: '委托与事件', path: '/csharp/09.delege&event', collapsable: true, children: [
              { title: '委托', path: '/csharp/09_1.delege' },
              { title: '事件', path: '/csharp/09_2.event' },
              { title: '委托事件进阶', path: '/csharp/09_3.advanced' },
            ]
          },
          { title: '泛型', path: '/csharp/10.genericity' },
          { title: 'Linq', path: '/csharp/11.linq' },
          { title: '语法糖', path: '/csharp/12.sugar' },
          { title: '异常处理', path: '/csharp/13.exception' },
        ],
      },

      ],

      '/winform/': [
        {
          title: 'WinForm简介',
          collapsable: false,
          children: [
            { title: 'WinFrom架构简介', path: '/winform/' },
            {
              title: '功能架构管理', path: '/winform/01.funcframe', children: [
                { title: '导出模块配置', path: '/winform/01_1.exportsettings' },
                { title: '系统参数定义', path: '/winform/01_2.paramsetting' },
                { title: '辅助资料定义', path: '/winform/01_3.auxdatasetting' },
                { title: '报表定义', path: '/winform/01_4.report' }
              ]
            },
            { title: '窗体界面设计', path: '/winform/02.formdesign' },
            { title: 'WnDataSource', path: '/winform/03.wndatasource' },
            { title: '控件库接口', path: '/winform/04.interface' },
            { title: '容器控件', path: '/winform/05.container' },
            { title: '菜单导航控件', path: '/winform/06.menu&navigator' },
            { title: '单值控件', path: '/winform/07.singlecontrol' },
            { title: '数据展示控件', path: '/winform/08.datacontrol' },
            { title: '模块设计原则', path: '/winform/09.moduledesign' },
            { title: '编程指南', path: '/winform/10.programmingguide' },
            { title: '编程规范', path: '/winform/11.programmingstandard' },
            { title: '环境搭建', path: '/winform/12.devenvironment' },
            { title: '代码调试', path: '/winform/13.debug' }
          ],
        },
      ],

      '/winformspecialtopic/':[
        {
          title:'简介',
          collapsable:false,
          children:[
            {title:'简介',path:'/winformspecialtopic/'},
            {title:'Grid查询',path:'/winformspecialtopic/gridlookup'},
            {title:'Form查询',path:'/winformspecialtopic/formlookup'},
            {title:'数据权限',path:'/winformspecialtopic/dataright'},
            {title:'常用方法',path:'/winformspecialtopic/commonfunc'},
          ]
        }
      ],
    },
    sidebarDepth: 1
  },

  head: [
    ['link', { rel: 'icon', href: '/logo.png' }],
    ['script', {}, `
            var _hmt = _hmt || [];
            (function() {
              var hm = document.createElement("script");
              hm.src = "https://hm.baidu.com/hm.js?d6b9b94a6fafaa41c63920e1af80bcaf";
              var s = document.getElementsByTagName("script")[0]; 
              s.parentNode.insertBefore(hm, s);
            })();
        `]
  ]
}
