# 系统参数定义

> 系统参数定义用于设定当前模块能配置哪些系统参数，并定义当前模块界面的控件信息。

## 什么是系统参数

> 一些模块在打开获取数据时，需要指定一些特定的参数，比如获取特定天数以内的数据等。有以下两种方法可以实现：

- 在功能架构管理配置模块参数
- 配置系统参数

虽然上面两种方法都能实现，但是两种方法还是有一定的差别的。

- 功能架构管理中配置的模块参数一般**不会让用户进行配置**
- 系统参数则可以开放给用户，让**用户根据                                                                                           需求自行配置**

## 模块界面

![](./static/images/01_04.png)

## 配置项说明

|配置项|配置项说明|
|-|-|
|参数代码|系统参数的唯一标识，使用时根据该代码获取系统参数|
|参数值|系统参数的值|
|参数标题|在系统参数配置界面用于初始化为相关配置控件的标题，支持多语言|
|参数类型|用于初始化配置该系统参数使用的控件|
|Grid查询代码|当参数类型是WnGridLookup时使用|
|Form查询代码|当参数类型是WnFormLookup时使用|
|背后值列|参数类型为WnGridLookup和WnFormLookup时使用，因为这两种类型支持背后值与显示值，用于指定用哪一列作为控件的背后值|
|获得焦点显示列|参数类型为WnGridLookup和WnFormLookup时使用，控件获得焦点时显示哪一列的值|
|未获得焦点显示列|参数类型为WnGridLookup和WnFormLookup时使用，控件未获得焦点时显示哪几列的值|
|是否接受额外之|参数类型为WnCombo和WnFormLookup时使用，指示控件能否接受控件数据源以外的值|
|是否允许修改|指定该系统参数是否允许在系统参数设定模块进行修改|
|下拉列表|参数类型为WnCombo时使用，用于设定其下拉数据源|
|列表查询|参数类型为WnLookup时使用，用于设定其下拉数据源，支持多语言|
