# 单值控件

## WnDate控件

### 属性

- IsAllowNullText: 是否允许手动输入空值，默认值：true,此属性不限定代码赋值
- AllowMouseWheel: 是否允许通过鼠标滚轮改动控件值
- EditorFormat: 日期显示格式.枚举值：  
  > LongYMD(yyyy年MM月dd日)  
    ShortYMD(yyyy/MM/dd)  
    LongYMDT(yyyy年MM月dd日 HH:mm)  
    ShortYMDT(yyyy/MM/dd HH:mm)  
    LongYM(yyyy年MM月)  
    ShortYM(yyyy/MM)  
    LongMD(MM月dd日)  
    ShortMD(MM/dd)  
    LongMDT(MM月dd日 HH:mm)  
    ShortMDT(MM/dd HH:mm)  
    Time(HH:mm)  
    默认值：LongYMD
- MaxValue: 允许设定的最大日期，默认值：DateTime.MaxValue
- MinValue: 允许设定的最小日期，默认值：DateTime.MinValue

## WnDecimal控件

### 属性

- AllowMouseWheel： 是否允许通过鼠标滚轮改动控件值  
- EditorFormat：  数值格式，默认值：###########0.00  
- MaxValue: 允许设定的最大数值，默认值：decimal.MaxValue
- MinValue: 允许设定的最小数值，默认值：decimal.MinValue
  
## WnInt控件

### 属性

- AllowMouseWheel： 是否允许通过鼠标滚轮改动控件值  
- EditorFormat：  数值格式，默认值：###########0
- MaxValue: 允许设定的最大数值，默认值：Int.MaxValue
- MinValue: 允许设定的最小数值，默认值：Int.MinValue
  
## WnInage控件

### 属性

- IsShowMenu： 是否允许使用菜单，默认值：true
- IsShowCut： 是否显示剪切菜单项，默认值：true
- IsShowCopy： 是否显示复制菜单项，默认值：true
- IsShowPaste： 是否显示粘贴菜单项，默认值：true
- IsShowDelete： 是否显示删除菜单项，默认值：true
- IsShowLoad： 是否显示加载菜单项，默认值：true
- IsShowSave： 是否显示保存菜单项，默认值：true
- IsShowZoom： 是否显示缩放菜单项，默认值：false
- IsShowScrollBar： 是否显示滚动条，默认值：true
- SizeMode： 图像显示模式，枚举值：
  >Clip(当图像大于控件时截取图像)  
  Stretch(不等比例改变图像大小，让图像铺满控件)  
  StretchHorizontal(只改变图像的宽度，让图像横向铺满控件)  
  StretchVertical(只改变图像高度，让图像纵向铺满控件)  
  Zoom(等比例改变图像大小，让图像横向或纵向铺满控件)  
  Squeeze(当图像大于控件时，表现形式同Zoom，当图像小于控件时，不改变图像大小)  
  默认值：Clip
- NullText: 未设图像时的背景文本，默认值：""，当设为空字符串且未设图像时的背景文本：No image data
- Image: 获取存储在控件中的图像
- ImageAlignment: 图像对齐方式，枚举值：
  > TopLeft(左上)  
  TopCenter(中上)  
  TopRight(右上)  
  MiddleLeft(左中)  
  MiddleCenter(居中)  
  MiddleRight(右中)  
  BottomLeft(左下)  
  BottomCenter(中下)  
  BottomRight(右下)  
  默认值：MiddleCenter
- ZoomPercent: 图像缩放比例，只有当SizeMode设置为Clip时才起作用，允许设置1-10000中的一个值，当设置为100时图像为原始大小，默认值：100

## WnBtnEdit控件

### 属性

- Buttons: 控件按钮的集合，可以添加、删除按钮，按钮常用属性：
  > Caption(按钮的标题)  
  Image(按钮的图片)  
  Index(按钮的位置索引)  
  IsLeft(按钮是否居左)  
  Kind(按钮图片类型)  
  默认值：Ellipsis

## WnText控件

### 属性

- IsMultiLine: 获取或设置是否允许多行输入,默认值：false
- IsShowScrollBar: 获取或设置是否显示滚动条,默认值：false
  
## WnRichText

### 属性

- IsShowToolBar： 是否显示工具栏，默认值：true
- IsShowScrollBar： 是否显示滚动条，默认值：true
- TextValue： 获取控件的文本值
  
## WnConbo控件

### 属性

- ComboString：获取或设置控件的下拉列表数据源，默认值：null
- DropDownRowCount：获取或设置下拉框中显示的行数，默认值：7
- SelectedIndex：获取或设置下拉框当前选择项的索引，下拉框选择项第一项的索引为0，默认值：-1
- IsAcceptExtraData：获取或设置是否接收额外值，默认值：false

## WnLookup控件

### 属性

- LookupString：获取或设置控件的列表查询数据源，默认值：null
- DropDownWidth：获取或设置下拉框的宽度，默认值：0
- DropDownRowCount：获取或设置下拉框中显示的行数，默认值：7
- SelectedIndex：获取或设置下拉框当前选择项的索引，下拉框选择项第一项的索引为0，默认值：-1
- SelectedText：获取或设置选择项的显示值，默认值：""
- IsAllowEdit：获取或设置是否允许编辑，默认值：true

## WnGridLookup控件

### 属性

- GridLookupCode：获取或设置Grid查询代码，可指定应用层别名，格式：[应用层别名|]Grid查询代码，默认值：null
- ValueColumn：填充Value属性的Grid查询数据源列名
- FocusedColumn：获得焦点时显示的Grid查询据源列名
- UnFocusedColumn：未获焦点时显示的Grid查询数据源列名，多列时用逗号分隔
- KeyValues：以键值对<关键字，替换值>的形式保存Grid查询的关键字和替换值
- FillRules：以键值对<填充控件，数据集字段名>的形式保存Grid查询填充规则
- SelectedIndex：获取或设置下拉框当前选择项的索引，下拉框选择项第一项的索引为0，默认值：-1
- SelectedItem：获取下拉框当前选择项，默认值：null
- IsAllowEdit：获取或设置是否允许编辑，默认值：true

### 方法

- BindData：绑定Grid查询数据源

## WnFormLookup控件

### 属性

- IsMultiLine：获取或设置是否允许多行输入，默认值：false
- IsShowScrollBar：获取或设置是否显示滚动条，默认值：false
- FormLookupCode：获取或设置Form查询代码，可指定应用层别名，格式：[应用层别名|]Form查询代码，默认值：null
- ValueColumn：填充Value属性的Form查询结果集列名
- FocusedColumn：获得焦点时显示的数据源列名；格式：Form查询结果集列名[|源对象数据列名]
- UnFocusedColumn：未获焦点时显示的数据源列名，多列时用逗号分隔；格式：Form查询结果集列名[|源对象数据列名]
- FocusedValue：获得焦点时的显示值
- UnFocusedValue：未获得焦点时的显示值
- IsSpaceLookup：在控件值为空时按回车键是否执行Form查询，默认值：false
- IsAutoReLookup：当为控件赋值时是否自动重新获取Form查询数据，默认值：false
- KeyValues：以键值对<关键字，替换值>的形式保存Form查询的关键字和替换值
- FillRules：以键值对<填充控件，数据集字段名>的形式保存Form查询数据集填充规则
- IsAcceptExtraData：获取或设置是否接收Form查询之外的值，默认值：false

### 事件

- BeforeFormLookup：执行Form查询前引发事件
- AfterFormLookup：执行Form查询返回，填充数据前引发事件
- AfterFillData：执行Form查询返回，填充数据完成后引发事件

## SimpleButton控件

### 属性

- ButtonStyle：按钮样式，常用的样式：Default(默认值)、UltraFlat
- Appearance.TextOptions.HAlignment：按钮文字的水平对齐方式，常用的方式：Default(居中，默认值)、Near(居左) ，当样式为UltraFlat时，设定为Near
- Appearance.BackColor：按钮背景色，当样式为UltraFlat时，设定为Transparent
- DialogResult：作为对话框窗体按钮时的返回按键值
- Image：按钮小图标

### 事件

- Click：点击按钮时引发事件

## WnButton控件

继承自SimpleButton

## Label控件

### 属性

- AutoSize：是否自动调整大小，默认值：true
- Text：控件文本

## WnLabel控件

继承自Lable控件
