# 数据类控件

## 结构图

![数据类控件](../winform/static/images/数据类控件.png)

## 基础控件介绍

### TreeView

树形结构控件，WnTree继承自该控件

#### 属性

- AllowDrop：拖拽数据操作使用对象，当设置为true时，允许控件接受用户拖拽过来的数据
- BorderStyle：控件的边框样式，该属性在WnTree中已经被隐藏
- HideSelection：用于获取或设置当控件没有获得焦点时，控件的选中项是否高亮显示，默认值为true
- ImageList：用于获取或设置节点图片的集合对象，类型为ImageList

 <font color="red">**小知识：ImageList对象**</font>  

  - <font color="red">**ColorDepth：用来呈现图片的颜色数，值越大，图片越清晰。默认为Depth8Bit，编程设置值为Depth32bit。注意，这个属性要在图片添加到ImageList前设置，因为设置这个属性时不会更改已经添加的图片的颜色数** </font>
  - <font color="red">**Images：存储在控件的图片集合，通过索引器【包括索引和图片的键】从集合获取图片**</font>
  - <font color="red">**小知识：索引器的概念**</font>
  - <font color="red">**ImageSize：存储的图片对象的尺寸**</font>

- ImageIndex：用于获取或设置节点未选中时，节点图片的索引
- ImageKey：用于获取或设置节点未选中时，节点图片的键
- SelectedImageIndex：用于获取或设置节点选中时，节点图片的索引
- SelectedImageKey：用于获取或设置节点选中时，节点图片的键

<font color="red">**注意：图片的Index和Key是互斥的，后设置的起作用**</font>

- ItemHeight：用于获取或设置节点的高度
- Nodes：用于获取或获取根节点集合
- PathSeparator：用于获取或设置节点的FullPath路径中的连接符号
- Scrollable：用于获取或设置树对象的节点过多时，是否自动出现滚动条，默认值为true
- SelectedNode：用于获取或设置树对象的当前选中节点
- ShowLines：用于获取和设置是否在显示同级节点之间和父节点与子节点之间的连线，默认值为true
- ShowRootLines：用于获取和设置是否显示根节点之间的连线，默认值为true

<font color="red">**小思考：什么情况下需要设置不显示连线**</font>

- ShowNodeToolTip：用于获取和设置是否显示节点的提示信息，默认值为false

#### 事件

- BeforeSelect：树节点选中前触发，一般用于数据检查
- AfterSelect：树节点选中后触发，一般用于获取数据
- AfterCollapse：树节点折叠后触发
- AfterExpand：树节点展开后触发
- NodeMouseClick：用鼠标单击节点时触发
- NodeMouseDoubleClick：用鼠标双击节点时触发
- ItemDrag：用户开始拖拽节点是触发
- DragEnter：用户将拖拽对象拖进控件边缘时触发
- DragDrop：用户在完成拖拽操作时触发

#### 方法

- BeginUpdate：禁用控件重绘
- EndUpdate：启用控件重绘

<font color="red">**小思考：BeginUpdate和EndUpdate的意义**</font>

- DoDragDrop：开始拖拽操作

#### TreeNode属性

- ContextMenuStrip：用于获取或设置节点右键菜单
- FullPath：用于获取从根节点到当前节点的完整路径，值是用PathSeparator连接各级节点的显示文本。
- ImageIndex：用于获取或设置节点未选中时的图片索引
- ImageKey：用于获取或设置节点未选中时的图片的键
- SelectedImageIndex：用于获取或设置节点选中是的图片索引
- SelectedImageKey：用于获取或设置节点选中时的图片的键

<font color="red">**注意：树上和节点都有上面四个属性，本质区别是树上设置的对所有节点起作用，节点设置的只对当前节点起作用。节点的图片属性优先级高于树的图片属性**</font>

- Name：用于获取节点的名称
- Nodes：用于获取节点的子节点集合
- Parent：用于获取节点的父节点，类型为TreeNode，所以根节点的Parent为null
- Tag：object类型属性，用于放置用户自定义数据，在WnTree放置了用于构建当前节点的DataRow对象
- Text：用于获取或设置树节点的显示文本
- ToolTipText：用于获取或设置树节点的提示文本

### ChartControl

#### 属性

- AppearanceName：用于获取或设置图标元素外观名称，可选择的值请参考演示程序
- BackColor：用于获取或设置控件的背景色，控件图表以外区域的背景色
- BorderOptions：用于获取或设置控件的边框，包括设置边框的颜色(Color)、粗细(Thickness)、是否可见(Visible)等
- Diagram：用于获取或设置控件的图标属性，设置多坐标系图表时会使用
- Legend：用于获取或设置控件的图例属性
- OptionsPrint：用于获取或设置控件的打印属性
- PaletteName：用于获取或设置控件当前使用的调色板
- PaletteBaseColorNumber：配合PaletteName使用，从选定的调色板中获取一个颜色值，并把这个颜色值作为一个基准值生成其他剩余的颜色值
- SelectionMode：用于获取或设置控件选中其中的Series的模式。None，是不选中；Single，同一时间只有一个Series被选中；Multiple，直接用鼠标点击多选；- Extended：按下Ctrl和Shif键进行多选
- SeriesSelectionMode：用于获取或设置控件中每个Series中元素的选中模式。Point，选中Series中的一个元素；Series，选中整个Series

<font color="red">**注意：SelectionMode设置的是多个Series之间的选择模式，SeriesSelectionMode设置的是一个Series内元素的选中模式，但是SelectionMode同时又会对SeriesSelectionMode产生影响，影响其单选还是多选**</font>

- Series：用于获取或设置控件的序列对象属性
- Title：用于获取或设置控件的标题对象属性

#### 方法

- ExportTo[Html|Image|Mht|Pdf|Rtf|Xls]：把图表导出为各种格式文件
- ShowPrintPreview：显示打印预览窗口
- Print：打印

#### Series属性

- Name：用于设置Series的名称，如果不设置Legend的文本，将在Legend上显示Name
- DataSource：Series的数据源
- Points：Series中数据点的集合
- LegendText：图例的文本，优先级高于Name
- ShowInLegend：用于设置是否显示图例
- LegendTextPattern：用于设置图例文本的格式，具体设置请参考演示程序
- ArgumentDataMember：用于设置代表坐标轴X轴坐标的字段，一个坐标系只允许一个
- ValueDataMembers：用于设置代表坐标轴Y轴的字段，允许设置多个
- View：获取Series的视图对象

#### SeriesPoint属性

- Argument：设置点的X坐标
- Vaules：设置点的值

### GridControl

DEV控件，用于承载GridVeiw控件，WnGrid控件就是通过封装GridControl和GridView控件实现的。

#### 属性

- DataSource：用于获取和设置GridControl控件的数据源，类型为Object
- AllowRestoreSelectionAndFocusRow：用于获取和设置是否允许在排序、分组和过滤后仍然选中原来选中的行
- FocusView：用于获取和设置控件中获得焦点的View对象。在一个GridControl中可以存在多个View对象，并且View对象的类型可以不相同
- MainView：用于获取和设置GridControl控件的主视图
- ViewCollection：用于获取GridControl控件的视图的集合
- UseEmbeddedNavigator：用于获取或设置是否使用控件内置的导航器，默认值false
- EmbeddedNavigator：用于设置GridControl内置导航器的属性，包括导航器的颜色、按钮等
- IsFocused：用于获取当前GridControl是否获得焦点
- LevelTree：用于获取GridControl的GridLevelTree对象
- ShowOnlyPredefinedDetails：用于获取或设置在GridControl展开层级关系时，是否只显示在GridControl的LevelTree中定义过的节点

#### 事件

- DataSourceChanged：当数据源发生改变时触发
- FocusedViewChanged：当获得焦点的View对象发生改变时触发
- ViewRegistered：当子视图(Detail)创建时触发

#### 方法

- BeginUpdate：禁止控件重绘
- EndUpdate：开启控件重绘
- CreateView：创建一个BaseView对象
- ExportTo[Xls|Html|Mht|Pdf|Rtf|Text|Xlsx]：导出为各种类型的文件
- ShowPrintView：打印预览

### GridView

WnGrid控件封装的视图对象

#### 属性

- ActiveEditor：用于获取当前激活的编辑器
- IsFocusedView：用于指示当前GridView对象是否获得焦点
- IsEditing：用于指示当前GridVeiw是否正在编辑
- ActiveFilterString：用于获取或设置数据过滤表达式
- BestFitMaxRowCount：用于获取或设置用来计算最佳列宽度的行数。-1，参考标题和所有行；0，只参考标题；1，参考标题和第一行
- ColumnPanelRowHeight：用于获取或设置列标题行的高度，设置小于21无效，默认值-1
- IndicatorWidth：用于获取或设置行标题的宽度，设置小于16无效，默认值-1
- Columns：用于获取GridView所有列的集合（GridColumn集合）
- VisibleColumns：用于获取GridView所有可见列的集合
- DataRowCount：用于获取GridView真实的数据行行数，包括不可见行（分组折叠后的行）
- RowCount：用于获取GridView上的可见行，包括分组行
- DataSource：用于获取GridView的数据源对象
- DefaultRelationIndex：用于获取或设置GridView展开子视图时，默认显示的Detail表的Relation索引
- DetailHeight：用于获取或设置Detail视图的高度，如果高度大于实际高度，则按照实际高度显示
- DetailLevel：用于获取DetailView的层级
- LevelName：用于获取DetailView所在的关系的名称
- DetailTabHeaderLocation：用于获取或设置Detail标题的位置
- DetailVerticalIndent：用于获取或设置主行与子视图之间的距离，默认值0
- LevelIndent：用于获取或设置主行或分组航与子视图之间的缩进，默认值为-1
- Editable：用于获取GridView是否可编辑
- FocusedColumn：用于获取或设置GridVeiw的焦点列
- FocusedRowHandle：用于获取或设置GridView的焦点行
- FocusRectStyle：用于获取或设置焦点框的样式。None，没有焦点框；CellFocus，焦点单元格绘制；RowFocus，焦点行绘制
- FormatConditions：用于获取GridView条件格式集合，可以根据条件改变GridView的显示，例如前景色、背景色等
- FootPanelHeight：用于获取或设置FootPanel的高度，默认值为-1，设置23以下无效
- GridControl：用于获取GridView所在的GridControl对象
- GroupedColumns：用于获取分组列的集合
- GroupFormat：用于获取或设置分组行标题的显示格式。{0}代表列名，{1}代表值
- HorzScrollVisibility：用于获取或设置水平滚动条的显示格式，枚举值：Always、Auto和Never
- Images：用于获取或设置一个图片的集合对象，类型为ImageList
- IsDetailView：用于获取当前GridView是否是一个明细GridView
- ParentView：如果是DetailView，该属性用于获取或设置其所属的GridView对象
- SourceRow：获取DetailView的MasterRow对象（获取到的对象的类型为DataRowView）
- SourceRowHandle：获取DetailView的MasterRow对象的行索引
- SourceView：获取DetailView对象的MasterView对象

<font color="red">**注意：ParentView和SourceView的区别**</font>

- PreviewFieldName：用于获取或设置显示在Preview上的列的名称
- PreviewIndent：用于获取或设置Preview的水平缩进
- PreviewLineCount：用于获取或设置Preview能显示的文本行数
- RowSeparatorHeight：用于获取或设置行间距离
- ViewCaption：用于获取或设置GridView的标题

- **Appearance**

  - CustomizationFormHint：用于设置当CustomizationForm中无任何隐藏列时的显示文本的外观
  - DetailTip：用于设置DetailView提示信息的外观。需要设置OptionsDetail. EnableDetailToolTip为true才有效。当鼠标移动到明细表展开收缩按钮时显示提示信息
  - EvenRow：用于设置偶数行的外观。需要设置OptionsView.EnableAppearanceEvenRow为true
  - OddRow：用于设置奇数行的外观。需要设置OptionsView.EnableAppearanceOddRow为true
  - FocusedCell：用于设置焦点单元格的外观
  - FocusedRow：用于设置焦点行的外观
  - GroupRow：用于设置分组行的外观
  - Row：用于设置行外观
  - SelectedRow：用于设置选中行的外观
  - HideSelectionRow：用于设置当GridView没有激活时选中行的外观
  - HeaderPanel：用于设置列标题的外观
  - Preview：用于设置Preview的外观

- OptionsBehavior

  - AllowAddRows：用于获取或设置内置导航器的新增按钮是否可用
  - AllowDeleteRows：用于获取或设置内置导航器的删除按钮是否可用
  - AllowFixedGroups：用于获取或设置当滚动一个分组内的记录时，分组行是否一直可见
  - AllowIncrementalSearch：用于获取或设置是否允许用户通过录入值来快速定位记录

<font color="red">**注意：设置为true和false时的表现**</font>

- AutoExpandAllGroups：用于获取或设置是否自动展开所有分组
- AutoPopulateColumns：用于获取或设置当GridView绑定数据时如果没有对应列是否自动创建列
- AutoSelectAllInEditor：用于获取或设置是否允许通过回车键选中当前焦点单元格的所有内容
- AutoUpdateTotalSummary：用于获取或设置当修改单元格数据后是否自动计算修改列的汇总值
- Editable：用于获取或设置GridView是否可以编辑
- EditorShowMode：用于获取或设置编辑器激活的模式。枚举值有：Default、Click、MouseDown、MouseUp、MouseDownFocused
- ImmediateUpdateRowPosition：用于获取或设置存在过滤或排序时，新增或修改数据后是否立即发生响应
- ReadOnly：用于获取或设置GridView对象是否只读
- SmartVertScollBar：用于获取或设置，有滚动条的时候，最后一行能否滚动到GridView对象的顶部
- SummariesIgonreNullValues：用于获取或设置，在计算汇总值的时候是否忽略null值

- OpetionsCustomization

  - AllowColumnMoving：用于获取或设置是否允许用户通过拖拽的方式移动列的顺序
  - AllowColumnResizing：用于获取或设置是否允许用户通过拖拽的方式改变列宽
  - AllowFilter：用于获取或设置是否允许用户通过过滤下拉列表或FilterEditor过滤数据
  - AllowGroup：用于获取或设置是否允许用户通过拖拽的方式进行分组
  - AllowQuickHideColumns：用于获取或设置是否允许用户通过拖拽的方式隐藏列
  - AllowRowSizing：用于获取或设置是否允许用户通过拖拽的方式调节行的高度
  - AllowSort：用于获取或设置是否允许用户通过点击列标题对数据排序

- OpeionsDetail

  - AllowExpandEmptyDetails：用于获取或设置是否允许展开没有数据的DetailView
  - AllowOnlyOneMasterRowExpanded：用于获取或设置同一时间是否只允许展开一个主行
  - AllowZoomDetail：用于获取或设置是否允许通过DetailView对象左上角的放大镜让DetailView填充满GridVeiw区域
  - AutoZoomDetail：用于获取或设置当打开子视图的时候是否自动填充
  - EnableDetailToolTip：用于获取或设置DetailView对象的ToolTip是否可用
  - EnableMasterViewMode：用于获取或设置是否允许显示DetailVeiw
  - ShowDetailTabs：用于获取或设置DetailView对象所在的TabControl的卡片页标题是否可见
  - SmartDetailExpand：用于获取或设置当展开DetailView时，如果GridView有滚动条是否把当前MasterRow滚动成GridView显示界面的第一行
  - SmartDetailExpandButtonMode：用于获取或设置DetailVeiw展开按钮的显示模式。枚举值：Default、AlwaysEnabled、CheckAllDetails、CheckDefaultDetail

- OptionsFilter

  - AllowFilterEditor：用于获取或设置是否允许通过Filter Editor设置过滤条件
  - AllowMRUFilterList：用于获取或设置Filter Editor的过滤下拉列表是否可用
  - AllowMultiSelectInCheckedFilterPopup：用于获取或设置当过滤下拉列表为多选的时候，是否允许通过单击行的方式选中行
  - ColumnFilterPopupRowCount：用于获取或设置过滤下拉列表一屏显示记录的数据，默认为20，最小值为4，当列过滤下拉列表为CheckList多选模式时无效
  - DefaultFilterEditorView：用于获取或设置Filter Editor默认显示的卡片页，枚举值：Text、Visual、VisualAndText、TextAndVisual

- OptionsFind

  - AllowFindPanel：用于获取或设置是否允许用户通过列标题的右键菜单开启查找面板
  - AlwaysVisible：用于获取或设置Find Panel是否一直可见
  - ClearFindOnClose：用于获取或设置Find Panel关闭时是否清空已经设置的查找字符串
  - FindFilterColumn：用于获取或设置Find查找的作用列，*代表所有列。格式为：列名;列名;……
  - ShowCloseButton：用于获取或设置是否显示关闭Find Panel的按钮

- OptionsMenu

  - EnableColumnMenu：用于获取或设置用户是否可以使用标题右键菜单
  - EnableFooterMenu：用于获取或设置用户是否可以使用Footer的右键菜单
  - EnableGroupPanelMenu：用于获取或设置用户是否可以使用Group Panel的右键菜单
  - ShowAddNewSummaryItem：用于获取或设置是否在Footer的右键菜单显示AddNewSummary项

- OptionsNavigation

  - AutoFocusNewRow：用于获取或设置GridView添加新行的时候，是否自动定位到新增行
  - AutoMoveRowFocus：用于获取或设置当焦点在一行的起始或末尾时，是否允许通过左右箭头键让焦点上移或下移一行
  - EnterMoveNextColumn：用于获取或设置是否允许通过回车键移动焦点到下一个单元格
  - UseTabKey：用于获取或设置是否允许通过Tab/Shift+Tab移动单元格焦点

- OptionsPrint

  - AutoWidth：用于获取或设置是否自动根据打印纸张的宽度调整数据列宽
  - EnableAppearanceEvenRow：用于获取或设置打印或导出时Even Row的外观设置是否有效，需要设置OptionsPrint.UsePrintStyle为true
  - EnableAppearanceOddRow：用于获取或设置打印或导出时Odd Row的外观设置是否有效，需要设置OptionsPrint.UsePrintStyle为true
  - ExpandAllDetail：用于获取或设置导出或打印时，是否展开所有的DetailView
  - PrintDetials：用于获取或设置当存在DetailView时，是否打印DetailView

- OptionsSelection

  - MultiSelect：用于获取或设置是否允许多选
  - MultiSelectMode：用于获取或设置多选模式，枚举值：CellSelect、RowSelect

- OptionsView

  - AllowCellMerge：用于获取或设置是否允许合并单元格，不允许跨列合并
  - ColumnAutoWidth：用于获取或设置是否根据GridView的宽度来自动调整列宽
  - EnableAppearanceEvenRow：用于获取或设置是否使用EvenRow的外观设置
  - EnableAppearanceOddRow：用于获取或设置是否使用OddRow的外观设置
  - GroupDrawMode：用于获取或设置分组的绘制模式，枚举值：Default、Standard、Office2003
  - HeaderFilterButtonShowMode：用于获取或设置过滤按钮的显示模式，枚举值：Default、Button、SmartTag
  - RowAutoHeight：用于获取或设置是否允许根据内容调整行高度
  - ShowAutoFilterRow：用于获取或设置是否显示过滤行
  - ShowColumnHeader：用于获取或设置是否显示列标题
  - ShowIndicator：用于获取或设置是否显示行标题
  - ShowFooter：用于获取或设置是否显示Footer
  - ShowGroupPanel：用于获取或设置是否显示分组面板
  - ShowHorizontalLines：用于获取或设置是否显示水平分隔线
  - ShowVerticalLines：用于获取或设置是否显示垂直分隔线
  - ShowPreview：用于获取或设置是否显示Preview
  - ShowPreviewRowLines：用于获取或设置是否显示PreVeiw水平线
  - ShowViewCaption：用于获取或设置是否显示标题

#### 事件

- BeforeLeaveRow：切换行前触发的时间，经常用于数据检查
- CellValueChanging：单元格值发生改变时触发，经常用于数据同步和数据检查
- CellValueChanged：单元格值发生改变后触发，经常用于数据检查和数据处理
- Click：单击控件时触发。当GridView可编辑时，左键单击是激活单元格编辑器，此时不会触发Click事件
- ColumnFilterChanged：当列的过滤条件发生改变后触发
- ColumnUnboundExpressionChanged：当列的UnboundExression属性发生改变时触发
- CustomColumnDisplayText：用于自定义列显示文本的事件
- DataSourceChanged：当GridView数据源发生改变时触发
- DoubleClick：双击GridView时触发
- EndSorting：排序完成后触发
- FocusedColumnChanged：当焦点列发生改变时触发
- FocusedRowChanged：当焦点行发生改变时触发
- GridMenuItemClick：单击GridMenu的右键菜单时触发的事件
- GotFocus：GridView获得焦点后触发的事件
- KeyDown：GridVeiw的按键事件，当编辑器被激活后按键事件无效
- KeyPress：GridVeiw的按键事件，当编辑器被激活后按键事件无效
- KeyUp：GridView释放按键事件，当编辑器被激活后按键事件无效
- LostFocus：GridView失去焦点后触发的事件
- MasterRowExpanding：主行展开前触发的事件
- MasterRowExpanded：主行展开后触发的事件
- MasterRowGetRelationCount：DetailView显示或隐藏时触发，用户可以通过该事件指定Relation的个数
- MasterGetRelationDisplayCaption：DetailView的标题显示时触发，用户可以通过该事件指定DetailView的标题
- MouseDown：鼠标按下时触发的事件，如果鼠标在已激活的编辑器按下，此时不触发
- MouseEnter：鼠标移到GridView范围内触发
- MouseLeave：鼠标离开GridView范围后触发
- MouseMove：鼠标在GridView上移动时触发，鼠标在已激活的编辑器上移动不触发
- MouseUp：在GridView上释放鼠标时触发，如果鼠标在已激活的编辑器上释放，不触发
- PopupMenuShowing：右键菜单打开时引发的事件
- RowCountChanged：显示行数发生改变时触发的事件
- SelectionChanged：多选模式时，当选择项发生改变时触发的事件
- ShowingEditor：在GridView的单元格编辑器启动前触发的事件
- ShownEditor：在GridVeiw的单元格编辑器启动后触发的事件
- ValidateRow：行数据验证事件，当切换行时触发
- ValidatingEditor：单元格数据验证事件，当焦点离开单元格编辑器时触发

#### 方法

- CancelUpdateCurrentRow：取消当前行的数据修改，方法调用前必须保证行没有切换，编辑器已经关闭
- UpdateCurrRow：验证数据并把数据提交到数据源，切换行时会自动触发该方法
- HideEditor：关闭编辑器，并取消当前单元格的修改
- PostEditor：不关闭编辑器，将单元格正在修改的数据提交到数据源
- MoveBy：焦点移动到指定的行
- MoveFirst：焦点移动到第一行
- MoveLast：焦点移动到最后一行
- MoveNext：焦点移动到下一行
- MovePrev：焦点移动到前一行
- AddNewRow：新增一行
- BestFitColumns：根据列内容自动调整列宽
- CalcColumnBestWidth：获取指定列的最佳宽度
- CalcHitInfo：获取鼠标在GridView上单击时的GridHitInfo对象
- ClearColumnsFilter：清除所有列的过滤条件
- ClearGrouping：清除分组
- ClearSorting：清除排序
- CollaspeAllDetails：折叠所有DetailView
- CollaspeAllGroup：折叠所有的分组
- CollaspeGroupRow：折叠指定的分组行。注意：分组行的索引从-1开始
- CollaspeMasterRow：折叠指定的MasterRow
- ColumnCustomization：打开Customization窗口
- DestroyCustomization：关闭Customization窗口
- DeleteRow：删除指定位置的行
- DeleteSelectedRow：删除选中的行
- ExpandAllGroups：展开所有的分组行
- ExpandGroupRow：展开指定的分组
- ExpandMasterRow：展开指定的MasterRow
- ExportTo[Html|Mht|Pdf|Text|Xls|Xlsx]：导出为各种类型的文件
- Focus：使控件获得焦点
- GetDetailView：根据指定的MasterRow索引和Relation获得一个DetailView
- GetDisplayTextByColumnValue：根据指定列的格式来格式化一个值
- GetDataRow：根据行索引获取一个DataRow对象
- GetDataSourceRowIndex：获取指定行在数据源中的索引
- GetRow：根据行索引获取一个DataRowView对象
- GetRowCellDisplayText：获取指定单元格的显示值
- GetRowCellValue：获取指定单元格的值
- SetRowCellValue：给指定的单元格赋值
- GetFocusedDataRow：获取当前行，类型为DataRow
- GetFocusedDataSourceRowIndex：获取当前行在数据源中的行索引
- GetFocuedRow：获取当前行，类型为DataRowView
- GetFocusedRowCellDisplaytext：获取焦点单元格的显示文本
- GetFocusedRowCellValue：获取焦点单元格的值
- GetGroupSummaryDisplayText：获取指定分组和汇总项的显示值
- GetGroupSummaryValue：获取指定分组和汇总项的值
- GetGroupSummaryText：获取指定分组在分组行上的汇总内容
- GetRowHandle：获取指定行的行索引
- GetSelectedRows：获取选中的行
- GetVisibleColumn：获取指定位置的列(可见列)
- HideFindPanel：关闭查找面板
- IsFilterRow：判断指定行是否是过滤行
- IsGroupRow：判断指定行是否是分组行
- IsMasterRow：判断指定行是否是MasterRow
- IsRowSelected：判断指定行是否选中
- ClearSelection：多选模式下，清楚所有的选中
- SelectAll：多选模式下，选中所有的行
- SelectRow：多选模式下，选择指定的行
- SelectRows：多选模式下，选择指定的行
- UnSelectRow：多选模式下，去掉指定行的选中状态
- StartIncrementalSearch：执行查找指定的字符串

### GridColumn

#### 属性

- Caption：用于获取或设置列的标题
- ColumnEdit：用于获取或设置列的编辑器控件
- ColumnEditName：用于获取或设置列的编辑器名称
- ColumnHandle：用于获取或设置关联数据源列的索引
- FieldName：用于获取或设置关联数据源列的名称
- ColumnType：用于获取列的数据类型
- DisplayFormat：用于获取或设置列的显示格式
- FieldNameSortGroup：获取或设置一个列名，当按照该列设置分组或排序时实际上是按照该属性配置的列进行分组或排序
- FilterInfo：用于获取或设置过滤条件
- FilterMode：获取或设置列的过滤模式，枚举值：DisplayText、Value
- Fixed：用于获取或设置列的锁定模式，枚举值：None、Left、Right
- GroupFormat：用于设置分组行的显示格式
- GroupIndex：用于设置列在分组列中的层级。注意：多列设置同一个值，后设置的有效；多列设置为不同的值，但是后设置的值小，则后设置的起效；无分组列，如果第一个设置的列的值不为0，则默认修改为0
- GroupInterval：用于设置分组列的数据分组依据，枚举值：Default、Value、Date、DateMonth、DateYear、DateRange、Alphabetical、DisplayText
- Images：用于获取列标题图片的集合
- ImageIndex：用于设置当前列使用的图片索引
- ImageAlignment：用于获取或设置列标题图片的位置
- MaxWidth：用于获取或设置列的最大宽度
- MinWidth：用于获取或设置列的最小宽度
- ShowButtnMode：用于获取或设置列编辑按钮的显示模式，枚举值：Default、ShowAlways、ShowForFocusedCell、ShowForFocusedRow、ShowOnlyInEditor
SortMode：用于获取或设置列排序的模式，枚举值：Default、Value、DisplayText、Custom
- SortOrder：用于设置列排序的升降序
- ToolTip：用于获取或设置列的自定义提示信息
- UnboundExpression：获取或设置一个表达式，用于计算无缘列的值
- UnboundType：用于获取或设置无缘列的数据类型
- View：用于获取列所在的视图
- Visible：用于获取或设置列是否可见
- VisibleIndex：用于获取或设置可见列的顺序，-1为不可见
- Width：用于获取或设置列宽度

- OptionsColumn

  - AllowEdit：用于获取或设置列是否可以编辑
  - AllowFocus：用于获取或设置列是否可以获得焦点
  - AllowGroup：用于获取或设置是否可以按照该列分组
  - AllowMerge：用于获取或设置是否可以合并单元格
  - AllowMove：用于获取或设置是否可以拖拽移动该列
  - AllowShowHide：用于获取或设置是否可以通过拖拽隐藏该列
  - AllowSize：用于获取或设置是否允许通过拖拽的方式改变列宽
  - AllowSort：用于获取或设置是否允许排序
  - FixedWidth：用于获取或设置是否锁定列宽
  - ReadOnly：用于获取或设置列是否只读
  - ShowCaption：用于获取或设置列是否显示标题
  - TabStop：用于获取或设置按Tab键是否直接跳过该列

- **OptionsFilter**

  - AllowAutoFilter：用于获取或设置列是否可以通过过滤行进行过滤
  - AllowFilter：用于获取或设置列标题上的过滤按钮是否可见
  - AllowFilterModeChanging：用于获取或设置列标题上的右键菜单是否显示FilterMode选项
  - AutoFilterCondition：用于获取或设置列的过滤模式，枚举值：Default、Contains、Equals、Like

#### 方法

- BestFit：设置列为最合适宽度
- ClearFilter：清楚过滤信息
- Group：按照该列分组
- UnGroup：撤销分组

### TreeList

树和列表的结合体，常用于展示有层级结构的数据，WnTreeGrid继承自它

#### 属性

- DataSource：用于获取或设置数据源，类型为object类型
- KeyFieldName：用于获取或设置节点字段名称
- ParentFieldName：用于获取或设置父节点字段名称，与KeyFieldName配套使用，构建节点间的父子关系

<font color="red">**注意：默认情况下，构建父子关系的列不会在TreeList上显示**</font>

- Columns：用于获取TreeListColumn集合
- Appearance.EvenRow：与GridVeiw的属性一致
- Appearance.OddRow：与GridVeiw的属性一致
- Appearance.FocusedCell：用于设置焦点单元格的显示样式
- Appearance.FocusedRow：用于设置焦点行的显示样式
- Appearance.HideSelectionRow：用于设置TreeList失去焦点时，选中行的显示样式
- FilterCondition：过滤条件集合，OptionsBehavior.EnableFilterString设置为true有效。

<font color="red">**注意：符合条件的数据将被过滤掉**</font>

- FormatConditions：用于设置TreeList的条件样式，符合条件的单元格或行将按照设置的格式显示
- EditingValue：用于获取焦点单元格正在编辑的值
- FocusedColumn：用于获取或设置当前列
- FocusedNode：用于获取或设置当前节点
- Nodes：用于获取TreeList根节点集合
- Selection：用于获取选中节点的集合
- OptionsBehavior.DragNodes：用于获取或设置是否可以拖拽节点
- OptionsBehavior.Editable：用于获取或设置TreeList是否可以编辑
- OptionsBehavior.EnableFiltering：用于获取或设置是否允许通过过滤栏过滤
- OptionsNavigation.EnterMoveNextColumn：用于获取或设置是否允许通过回车将焦点移动到下一个列
- OptionsNavigation.UseTabKey：用于获取或设置是否允许通过Tab键将焦点移动到下一个列
- OptionsSelection.MultiSelect：用于获取或设置TreeList是否允许多选，多选时可以通过按下Shift或Control键多选
- OptionsView.AutoWidth：用于获取或设置列宽是否根据TreeList大小自动调整，编程一般设置为false
- OptionsView.EnableAppenaceEvenRow：用于获取或设置偶数行的外观设置是否起效
- OptionsView.EnableAppenceOddRow：用于获取或设置奇数行的外观设置是否起效
- OptionsView.ShowAutoFilterRow：用于获取或设置是否显示过滤行
- OptionsView.ShowCheckBoxes：用于获取或设置是否在节点前显示Check列
- OptionsView.ShowIndicator：用于获取或设置是否显示行指示器1
- OptionsView.ShowRowFooterSummary：用于获取或设置是否显示合计栏（每个叶子节点行下）
- OptionsView.ShowSummaryFooter：用于获取或设置是否显示TreeList的Footer面板（TreeList的最下方）

#### 事件

- BeforeCheckNode：节点的Check列选中状态发生改变前触发的事件
- AfterCheckNode：节点的Check列选中状态发生改变后触发的事件
- BeforeFocusNode：节点得到焦点前触发的事件
- AfterFocusNode：节点得到焦点后触发的事件
- CellValueChanging：单元格的值发生改变时触发的事件
- CellValueChanged：单元格的值发生改变后触发的事件

#### 方法

- AppendNode：新增节点方法
- DeleteNode：删除指定节点方法，如果有子节点，则一起删除
- DeleteSelectedNodes：删除所有选中的节点，如果有子节点，则一起删除
- ClearNodes：清楚所有节点
- CopyNode：复制指定节点
- AddFilter：添加过滤条件，OptionsBehavior.EnableFiltering设置为true时起效
- ExportToXls：导出Excel，格式为xls
- ExportToXlsx：导出Excel，格式为xlsx
- ExpandAll：展开所有的节点
- CollapseAll：收缩所有节点
- CheckAll：将Check列全部设置为Checked状态
- UnCheckAll：将Check列全部设置为UnChecked状态
- ShowPrintView：打印预览
- FindNodeByFieldValue：根据字段值查找节点
- GetDataRecordByNode：获取节点对应的数据记录
- BestFitColumns：所有列宽自适应
- MoveFirst：移动到第一个节点
- MoveLast：移动到最后一个节点
- MovePrev：移动到上一个节点
- MoveNext：移动到下一个节点

- **TreeListColumn**
  
  - OptionsColumn.AllowFocus：用于获取或设置列是否允许获得焦点
  - Options.AllowSort：用于获取或设置列是否允许排序
  - Fixed：用于获取或设置列的锁定模式
  - Format：用于设置列的格式，仅对日期和数值类型的列有效
  - Visible：用于获取或设置列是否可见
  - VisibleIndex：用于获取或设置列的显示顺序
  - ColumnEdit：用于获取和设置列的编辑器
  - AllNodesSummary：用于获取或设置是否对列的所有节点进行汇总，必须将OptionsView.ShowSummaryFooter设置为true
  - RowSummaryFooterStrFormat：用于获取或设置列的汇总格式字符串
  - RowFooterSummary：用于获取或设置汇总类型
  - FieldName：用于获取或设置当前列对应的数据源字段名

### TreeListNode

#### 属性

- Checked：用于获取或设置指定节点是否选中
- Expanded：用于获取或设置指定节点是否展开
- Level：用于获取指定节点的层级
- Nodes：用于获取节点的子节点集合
- ParentNode：用于获取节点的父节点

#### 方法

- CheckAll：对指定节点及其所有子节点的CheckBox列进行勾选
- UnCheckAll：取消对当前节点及其所有子节点的CheckBox列的勾选
- ExpandAll：展开当前节点及其所有子节点
- GetValue：获取节点指定列的值
- SetValue：设定节点指定列的值

### PivotControl

#### 属性

- DataSource：用于设置PivotControl的数据源
- Fields：Pivot对象的字段集合
- FormatConditions：条件格式集合，用于根据条件设置PivotControl的显示样式
- HeaderImages：Header区域的图片集合
- ValueImages：Value区域的图片集合

#### 事件

- FieldValueImageIndex：在事件中允许设定图片